/*******************************************************************
*
*  DESCRIPTION: Atomic Model DataTransmitter
*
*  AUTHOR: Mohammad Moallemi
*
*  EMAIL: mmoallem@connect.carleton.ca
*
*
*  DATE: 1/11/2007
*
*******************************************************************/
#ifndef __DATATRANSMITTER_H
#define __DATATRANSMITTER_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class DataTransmitter: public Atomic
{
public:
	DataTransmitter( const string &name = "DataTransmitter" ) ;	 // Default constructor

	

	virtual string className() const
		{return "DataTransmitter";}

protected:
	Model &initFunction()
		{   got_data1 = 0;
			got_data2 = 0;
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &in3;
    const Port &in4 ;
    Port &out3;
    Port &out4 ;
    Time processingtime;
    int   got_data1, got_data2;
	

    
};	// class DataTransmitter


#endif    //__DATATRANSMITTER_H
