/*******************************************************************
*
*  DESCRIPTION: Atomic Model PINChecker
*
*  AUTHOR: Mohammad Moallemi
*
*  EMAIL: mmoallem@connect.carleton.ca
*
*
*  DATE: 1/11/2007
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>
#include "PINChecker.h"  // base header
#include "message.h"       // InternalMessage ....
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: PINChecker
* Description: constructor
********************************************************************/
PINChecker::PINChecker( const string &name )
: Atomic( name )
, in2( addInputPort( "in2" ) )
, out2( addOutputPort( "out2" ) )
, processingtime (0,0,2,0)
{
	
	string time1( MainSimulator::Instance().getParameter( description(), "processingtime" ) ) ;

	if( time1 != "" )
		processingtime = time1 ;

}

/*******************************************************************
* Function Name: externalFunction
* Description: the PINChecker receives PIN number
********************************************************************/
Model &PINChecker::externalFunction( const ExternalMessage &msg )
{
  if ( this->state() == passive)
  {
  
    if (msg.port() == in2)
     {
       replypin = 1;  //set it to True
       holdIn(active, processingtime);
     }

  }
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &PINChecker::internalFunction( const InternalMessage & )
{
	passivate();
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &PINChecker::outputFunction( const InternalMessage &msg )
{

      if ( replypin == 1 )
        {
         sendOutput( msg.time(),out2, 1);
        }
         
	return *this;
}


