/*******************************************************************
*
*  DESCRIPTION: Atomic Model UserLaptop
*
*  AUTHOR: Mohammad Moallemi
*
*  EMAIL: mmoallem@connect.carleton.ca
*
*
*  DATE: 1/11/2007
*
*******************************************************************/
#ifndef __USERLAPTOP_H
#define __USERLAPTOP_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class UserLaptop: public Atomic
{
public:
	UserLaptop( const string &name = "UserLaptop" ) ;	 // Default constructor

	

	virtual string className() const
		{return "UserLaptop";}

protected:
	Model &initFunction()
		{   user_connect = net_available = net_connected = data = 0;
			PIN = 123;
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &connect;
    const Port &availability ;
    const Port &connection ;
    const Port &data_in;
    Port &search_network ;
    Port &send_PIN ;
    Port &data_out;
    Port &internet_data;
    Time searchnettime;
    Time PINverificationtime;
    Time transmissiontime;
    int  user_connect, net_available, net_connected, data, PIN;
};	// class UserLaptop


#endif    //__USERLAPTOP_H
