/*******************************************************************
*
*  DESCRIPTION: Atomic Model WirelessManager
*
*  AUTHOR: Mohammad Moallemi
*
*  EMAIL: mmoallem@connect.carleton.ca
*
*
*  DATE: 1/11/2007
*
*******************************************************************/

/** include files **/
#include <math.h>            // fabs( ... )
#include <stdlib.h>
#include "WirelessManager.h"  // base header
#include "message.h"       // InternalMessage ....
#include "mainsimu.h"      // class MainSimulator
#include "strutil.h"       // str2float( ... )

/*******************************************************************
* Function Name: WirelessManager
* Description: constructor
********************************************************************/
WirelessManager::WirelessManager( const string &name )
: Atomic( name )
, in1( addInputPort( "in1" ) )
, out1( addOutputPort( "out1" ) )
, processingtime (0,0,2,0)
{
	
	string time1( MainSimulator::Instance().getParameter( description(), "processingtime" ) ) ;

	if( time1 != "" )
		processingtime = time1 ;

}

/*******************************************************************
* Function Name: externalFunction
* Description: the WirelessManager receives Search Network signals
********************************************************************/
Model &WirelessManager::externalFunction( const ExternalMessage &msg )
{
  if ( this->state() == passive)
  {
  
    if (msg.port() == in1)
     {
       replysearch = 1;  //set it to True
       holdIn(active, processingtime);
     }

  }
	return *this ;
}

/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &WirelessManager::internalFunction( const InternalMessage & )
{
	passivate();
	return *this;
}

/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &WirelessManager::outputFunction( const InternalMessage &msg )
{

      if ( replysearch == 1 )
        {
         sendOutput( msg.time(),out1, 1);
        }
         
	return *this;
}


