/*******************************************************************
*
*  DESCRIPTION: Atomic Model WirelessManager
*
*  AUTHOR: Mohammad Moallemi
*
*  EMAIL: mmoallem@connect.carleton.ca
*
*
*  DATE: 1/11/2007
*
*******************************************************************/
#ifndef __WIRELESSMANAGER_H
#define __WIRELESSMANAGER_H

/** include files **/
#include "atomic.h"  // class Atomic


/** declarations **/
class WirelessManager: public Atomic
{
public:
	WirelessManager( const string &name = "WirelessManager" ) ;	 // Default constructor

	

	virtual string className() const
		{return "WirelessManager";}

protected:
	Model &initFunction()
		{   replysearch = 0;
			
                      this -> passivate();
                      return *this;}

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
	const Port &in1;
    Port &out1 ;
    Time processingtime;
    int   replysearch;
	

    
};	// class WirelessManager


#endif    //__WIRELESSMANAGER_H
